;   File   : hfamily.pl
;   Author : E.P. Stabler, Jr
;   Updated: 1988
;   Purpose: This is a first order formulation of Hinton's family trees
;            using has_relation predicates over individuals



(defun make_english_family ()
  (make_struc 'english_family 'family_tree
	      '(family ((has_father (arthur christopher) E1)
			(has_father (victoria christopher) E2)
			(has_father (colin james) E3)
			(has_father (charlotte james) E4)
			(has_father (james andrew) E5)
			(has_father (jennifer andrew) E6)
			(has_mother (arthur penelope) E7)
			(has_mother (victoria penelope) E8)
			(has_mother (colin victoria) E9)
			(has_mother (charlotte victoria) E10)
			(has_mother (james christine) E11)
			(has_mother (jennifer christine) E12)
			(has_husband (margaret arthur) E13)
			(has_husband (penelope christopher) E14)
			(has_husband (victoria james) E15)
			(has_husband (christine andrew) E16)
			(has_husband (jennifer charles) E17)
			(has_wife (arthur margaret) E18)
			(has_wife (christopher penelope) E19)
			(has_wife (james victoria) E20)
			(has_wife (andrew christine) E21)
			(has_wife (charles jennifer) E22)
			(has_son (christopher arthur) E23)
			(has_son (penelope arthur) E24)
			(has_son (andrew james) E25)
			(has_son (christine james) E26)
			(has_son (james colin) E27)
			(has_son (victoria colin) E28)
			(has_daughter (christopher victoria) E29)
			(has_daughter (penelope victoria) E30)
			(has_daughter (andrew jennifer) E31)
			(has_daughter (christine jennifer) E32)
			(has_daughter (victoria charlotte) E33)
			(has_daughter (james charlotte) E34)
			(has_brother (victoria arthur) E35)
			(has_brother (jennifer james) E36)
			(has_brother (charlotte colin) E37)
			(has_sister (arthur victoria) E38)
			(has_sister (james jennifer) E39)
			(has_sister (colin charlotte) E40)
			(has_uncle (colin arthur) E41)
			(has_uncle (charlotte arthur) E42)
			(has_uncle (colin charles) E43)
			(has_uncle (charlotte charles) E44)
			(has_aunt (colin jennifer) E45)
			(has_aunt (charlotte jennifer) E46)
			(has_aunt (colin margaret) E47)
			(has_aunt (charlotte margaret) E48)
			(has_nephew (arthur colin) E49)
			(has_nephew (jennifer colin) E50)
			(has_nephew (charles colin) E51)
			(has_nephew (margaret colin) E52)
			(has_niece (arthur charlotte) E53)
			(has_niece (jennifer charlotte) E54)
			(has_niece (charles charlotte) E55)
			(has_niece (margaret charlotte) E56)
			(male (arthur) E57)
			(male (christopher) E58)
			(male (colin) E59)
			(male (james) E60)
			(male (andrew) E61)
			(male (charles) E62)
			(female (victoria) E63)
			(female (charlotte) E64)
			(female (penelope) E65)
			(female (jennifer) E66)
			(female (margaret) E67)
			(female (christine) E68)
         		(english (arthur) E69)
			(english (christopher) E70)
			(english (colin) E71)
			(english (james) E72)
			(english (andrew) E73)
			(english (charles) E74)
			(english (victoria) E75)
			(english (charlotte) E76)
			(english (penelope) E77)
			(english (jennifer) E78)
			(english (margaret) E79)
			(english (christine) E80)))))

(defun make_italian_family ()
  (make_struc 'italian_family 'family_tree
	      '(family ((has_father (emilio roberto) I1)
			(has_father (lucia roberto) I2)
			(has_father (alfonso marco) I3)
			(has_father (sophia marco) I4)
			(has_father (marco pierro) I5)
			(has_father (angela pierro) I6)
			(has_mother (emilio maria) I7)
			(has_mother (lucia maria) I8)
			(has_mother (alfonso lucia) I9)
			(has_mother (sophia lucia) I10)
			(has_mother (marco francesca) I11)
			(has_mother (angela francesca) I12)
			(has_husband (gina emilio) I13)
			(has_husband (maria roberto) I14)
			(has_husband (lucia marco) I15)
			(has_husband (francesca pierro) I16)
			(has_husband (angela tomaso) I17)
			(has_wife (emilio gina) I18)
			(has_wife (roberto maria) I19)
			(has_wife (marco lucia) I20)
			(has_wife (pierro francesca) I21)
			(has_wife (tomaso angela) I22)
			(has_son (roberto emilio) I23)
			(has_son (maria emilio) I24)
			(has_son (pierro marco) I25)
			(has_son (francesca marco) I26)
			(has_son (marco alfonso) I27)
			(has_son (lucia alfonso) I28)
			(has_daughter (roberto lucia) I29)
			(has_daughter (maria lucia) I30)
			(has_daughter (pierro angela) I31)
			(has_daughter (francesca angela) I32)
			(has_daughter (lucia sophia) I33)
			(has_daughter (marco sophia) I34)
			(has_brother (lucia emilio) I35)
			(has_brother (angela marco) I36)
			(has_brother (sophia alfonso) I37)
			(has_sister (emilio lucia) I38)
			(has_sister (marco angela) I39)
			(has_sister (alfonso sophia) I40)
			(has_uncle (alfonso emilio) I41)
			(has_uncle (sophia emilio) I42)
			(has_uncle (alfonso tomaso) I43)
			(has_uncle (sophia tomaso) I44)
			(has_aunt (alfonso angela) I45)
			(has_aunt (sophia angela) I46)
			(has_aunt (alfonso gina) I47)
			(has_aunt (sophia gina) I48)
			(has_nephew (emilio alfonso) I49)
			(has_nephew (angela alfonso) I50)
			(has_nephew (tomaso alfonso) I51)
			(has_nephew (gina alfonso) I52)
			(has_niece (emilio sophia) I53)
			(has_niece (angela sophia) I54)
			(has_niece (tomaso sophia) I55)
			(has_niece (gina sophia) I56)
			(male (tomaso) I57)
			(male (emilio) I58)
			(male (alfonso) I59)
			(male (pierro) I60)
			(male (marco) I61)
			(male (roberto) I62)
			(female (angela) I63)
			(female (sophia) I64)
			(female (gina) I65)
			(female (francesca) I66)
			(female (lucia) I67)
			(female (maria) I68)
			(italian (tomaso) I69)
			(italian (emilio) I70)
			(italian (alfonso) I71)
			(italian (pierro) I72)
			(italian (marco) I73)
			(italian (roberto) I74)
			(italian (angela) I75)
			(italian (sophia) I76)
			(italian (gina) I77)
			(italian (francesca) I78)
			(italian (lucia) I79)
			(italian (maria) I80)))))










